# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from handle_detector/CylinderMsg.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg

class CylinderMsg(genpy.Message):
  _md5sum = "d942b1ab5090fe359833c2797e326219"
  _type = "handle_detector/CylinderMsg"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# A cylinder with its pose, radius, and extent.

geometry_msgs/Pose pose

float32 radius

float32 extent

# curvature axis (direction vector)
geometry_msgs/Vector3 axis
 
# normal axis (direction vector)
geometry_msgs/Vector3 normal

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z"""
  __slots__ = ['pose','radius','extent','axis','normal']
  _slot_types = ['geometry_msgs/Pose','float32','float32','geometry_msgs/Vector3','geometry_msgs/Vector3']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       pose,radius,extent,axis,normal

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(CylinderMsg, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.radius is None:
        self.radius = 0.
      if self.extent is None:
        self.extent = 0.
      if self.axis is None:
        self.axis = geometry_msgs.msg.Vector3()
      if self.normal is None:
        self.normal = geometry_msgs.msg.Vector3()
    else:
      self.pose = geometry_msgs.msg.Pose()
      self.radius = 0.
      self.extent = 0.
      self.axis = geometry_msgs.msg.Vector3()
      self.normal = geometry_msgs.msg.Vector3()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_7d2f6d().pack(_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.radius, _x.extent, _x.axis.x, _x.axis.y, _x.axis.z, _x.normal.x, _x.normal.y, _x.normal.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.axis is None:
        self.axis = geometry_msgs.msg.Vector3()
      if self.normal is None:
        self.normal = geometry_msgs.msg.Vector3()
      end = 0
      _x = self
      start = end
      end += 112
      (_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.radius, _x.extent, _x.axis.x, _x.axis.y, _x.axis.z, _x.normal.x, _x.normal.y, _x.normal.z,) = _get_struct_7d2f6d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_7d2f6d().pack(_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.radius, _x.extent, _x.axis.x, _x.axis.y, _x.axis.z, _x.normal.x, _x.normal.y, _x.normal.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.axis is None:
        self.axis = geometry_msgs.msg.Vector3()
      if self.normal is None:
        self.normal = geometry_msgs.msg.Vector3()
      end = 0
      _x = self
      start = end
      end += 112
      (_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.radius, _x.extent, _x.axis.x, _x.axis.y, _x.axis.z, _x.normal.x, _x.normal.y, _x.normal.z,) = _get_struct_7d2f6d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_7d2f6d = None
def _get_struct_7d2f6d():
    global _struct_7d2f6d
    if _struct_7d2f6d is None:
        _struct_7d2f6d = struct.Struct("<7d2f6d")
    return _struct_7d2f6d
